import React, { useState } from "react";
import Head from "next/head";
import Link from "next/link";
import { useRouter } from "next/dist/client/router";
import {
  Avatar,
  Button,
  CssBaseline,
  TextField,
  Typography,
  Container,
  CircularProgress,
} from "@material-ui/core";
import LockOutlinedIcon from "@material-ui/icons/LockOutlined";
import { makeStyles } from "@material-ui/core/styles";
import xantiayadakAPI from "../../apis/xantiayadak";

const useStyles = makeStyles((theme) => ({
  root: {
    height: "100vh",
    display: "flex",
    alignItems: "center",
    backgroundImage:
      "url(https://i.pinimg.com/originals/21/7f/73/217f736988c55aa3d63ae33551c33e97.jpg)",
    backgroundRepeat: "no-repeat",
    backgroundSize: "cover",
    backgroundPosition: "center",
  },
  paper: {
    padding: theme.spacing(3),
    display: "flex",
    flexDirection: "column",
    alignItems: "center",
    background:
      "linear-gradient(0deg, rgba(255, 255, 255, 0.2), rgba(255, 255, 255, 0.2)), linear-gradient(125.81deg, rgba(255, 255, 255, 0.4) 0%, rgba(255, 255, 255, 0.1) 68.57%)",
    backgroundBlendMode: "overlay, normal",
    backdropFilter: "blur(50px)",
  },
  avatar: {
    margin: theme.spacing(1),
    backgroundColor: theme.palette.secondary.main,
  },
  form: {
    width: "100%", // Fix IE 11 issue.
    marginTop: theme.spacing(1),
  },
  submit: {
    margin: theme.spacing(3, 0, 2),
  },
  errorMessage: {
    color: theme.palette.secondary.main,
    paddingTop: theme.spacing(2),
  },
}));

export default function SignIn() {
  const router = useRouter();
  const classes = useStyles();
  const [email, setEmail] = useState("");
  const [password, setPassword] = useState("");
  const [errorMessage, setErrorMessage] = useState("");
  const [isInRequest, setIsInRequest] = useState(false);

  const onSubmitSigninForm = async (e) => {
    e.preventDefault();
    setIsInRequest(true);
    try {
      const resSignin = await xantiayadakAPI.post("/auth", {
        email,
        password,
      });
      localStorage.setItem("auth-token", resSignin.data.data.token);
      setIsInRequest(false);
      setErrorMessage(
        " اعتبار سنجی با موفقیت انجام شد. درحال رفتن به پنل ادمین زانتیا یدک"
      );
      router.push("/admin");
    } catch (err) {
      setIsInRequest(false);
      if (err.response.status === 400) {
        setErrorMessage(err.response.data.message);
      } else {
        setErrorMessage(" چند دقیقه دیگر دوباره تلاش کنید");
      }
    }
  };

  return (
    <>
      <Head>
        <title>ورود | پنل ادمین زانتیا یدک</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/xantia-logo-svg-vector.svg" />
      </Head>
      <div className={classes.root}>
        <Container component="main" maxWidth="xs">
          <CssBaseline />
          <div className={classes.paper}>
            <Avatar className={classes.avatar}>
              <LockOutlinedIcon />
            </Avatar>
            <Typography component="h1" variant="h5">
              ورود به پنل ادمین
            </Typography>
            <Typography component="body2" className={classes.errorMessage}>
              {errorMessage}
            </Typography>
            <form className={classes.form} onSubmit={onSubmitSigninForm}>
              <TextField
                value={email}
                onChange={(e) => setEmail(e.target.value)}
                variant="outlined"
                margin="normal"
                required
                fullWidth
                id="email"
                label="ایمیل"
                name="email"
                autoComplete="email"
                type="email"
                autoFocus
              />
              <TextField
                value={password}
                onChange={(e) => setPassword(e.target.value)}
                variant="outlined"
                margin="normal"
                required
                fullWidth
                name="password"
                label="رمز عبور"
                type="password"
                id="password"
                autoComplete="current-password"
              />
              <Button
                type="submit"
                fullWidth
                variant="contained"
                color="primary"
                className={classes.submit}
                onSubmit={onSubmitSigninForm}
              >
                {isInRequest ? (
                  <CircularProgress color="inherit" size="25px" />
                ) : (
                  "Sign In"
                )}
              </Button>
            </form>
            <Link href="/">
              <a>
                <Typography variant="body2">
                  بازگشت به صفحه اصلی سایت
                </Typography>
              </a>
            </Link>
          </div>
        </Container>
      </div>
    </>
  );
}
